
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "opencv2/core/core_c.h"
#include "opencv2/highgui/highgui_c.h"
#include "opencv2/imgproc/imgproc_c.h"
#include "opencv2/calib3d/calib3d.hpp"

int main()
{
    int point_count = 8;
    
    CvMat* points1;
    CvMat* points2;
    CvMat* status;
    CvMat* fundamental_matrix;
    
    points1 = cvCreateMat(1, point_count, CV_64FC2);
    points2 = cvCreateMat(1, point_count, CV_64FC2);
    status = cvCreateMat(1, point_count, CV_8UC1);
    
    for (int i = 0; i < point_count; i++) {
        points1->data.db[i*2] = 1 + i;
        points1->data.db[i*2+1] = 2 + 3 * i;
        points2->data.db[i*2] = 2 + 1.5 * i;
        points2->data.db[i*2+1] = 3 + 2.2 * i;
    }
    
    fundamental_matrix = cvCreateMat(3,3,CV_32FC1);

    int result = cvFindFundamentalMat(points1, points2, fundamental_matrix, CV_FM_8POINT);
    
    for (int j = 0; j < 9; j++) {
        if (j % 3 == 0) {
            printf("\n");
        }
        printf("%f ", fundamental_matrix->data.fl[j]);
    }
        
    return 0;
    
}

